Index: palm/trunk/TESTS/cases/urban_environment_restart/MONITORING/urban_environment_restart_rc.000
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_restart/MONITORING/urban_environment_restart_rc.000	(revision 4703)
+++ palm/trunk/TESTS/cases/urban_environment_restart/MONITORING/urban_environment_restart_rc.000	(revision 4708)
@@ -36,10 +36,10 @@
   1    120 00:01:30.84   0.7560A  -2.3821  -1.3511   1.4801  0.069  0.66  -0.926E+00     44.  0.134E+01  0.646E-01  0.183E-02  0.181E-03   60   1  12    8  13   5    7  14   3    0.000    0.000       0
   1    121 00:01:31.60   0.7560A  -2.3822  -1.3448   1.4772  0.069  0.66  -0.906E+00     44.  0.134E+01  0.646E-01  0.184E-02  0.179E-03   60   0  10    8  13   5    8  14   3    0.000    0.000       0
-  1    122 00:01:32.35   0.7560A  -2.3822  -1.3391   1.4747  0.069  0.66  -0.902E+00     44.  0.134E+01  0.646E-01  0.185E-02  0.176E-03   60   0   9    8  13   5    8  14   3    0.000    0.000       0
+  1    122 00:01:32.35   0.7560A  -2.3823  -1.3391   1.4747  0.069  0.66  -0.902E+00     44.  0.134E+01  0.646E-01  0.185E-02  0.176E-03   60   0   9    8  13   5    8  14   3    0.000    0.000       0
   1    123 00:01:33.11   0.7560A  -2.3823  -1.3340   1.4713  0.069  0.65  -0.901E+00     44.  0.134E+01  0.646E-01  0.186E-02  0.174E-03   60   0   9    8  13   5    8  14   3    0.000    0.000       0
   1    124 00:01:33.87   0.7560A  -2.3824  -1.3292   1.4673  0.069  0.66  -0.902E+00     46.  0.134E+01  0.645E-01  0.187E-02  0.172E-03   60   0   8    8  13   5    8  14   3    0.000    0.000       0
   1    125 00:01:34.62   0.7560A  -2.3825  -1.3244   1.4625  0.069  0.65  -0.905E+00     46.  0.134E+01  0.644E-01  0.188E-02  0.170E-03   60  19   7    8  13   5    8  14   3    0.000    0.000       0
   1    126 00:01:35.38   0.7550A  -2.3825  -1.3188   1.4570  0.069  0.65  -0.912E+00     46.  0.134E+01  0.644E-01  0.188E-02  0.168E-03   60  19   6    8  13   5    8  14   3    0.000    0.000       0
-  1    127 00:01:36.13   0.7550A  -2.3826  -1.3120   1.4509  0.069  0.65  -0.929E+00     46.  0.134E+01  0.643E-01  0.189E-02  0.166E-03   60  19   6    8  13   5    8  14   3    0.000    0.000       0
+  1    127 00:01:36.13   0.7550A  -2.3826  -1.3119   1.4509  0.069  0.65  -0.929E+00     46.  0.134E+01  0.643E-01  0.189E-02  0.166E-03   60  19   6    8  13   5    8  14   3    0.000    0.000       0
   1    128 00:01:36.89   0.7550A  -2.3827  -1.3034   1.4448  0.069  0.64  -0.932E+00     46.  0.134E+01  0.642E-01  0.190E-02  0.164E-03   60  19   5    8  13   5    7  14   3    0.000    0.000       0
   1    129 00:01:37.64   0.7550A  -2.3828  -1.2933   1.4391  0.069  0.64  -0.960E+00     46.  0.134E+01  0.640E-01  0.190E-02  0.163E-03   60  18   3    8  13   5    7  14   3    0.000    0.000       0
@@ -57,5 +57,5 @@
   1    141 00:01:46.70   0.7550A  -2.3836  -1.2522   1.4337  0.068  0.62  -0.990E+00     48.  0.133E+01  0.614E-01  0.195E-02  0.165E-03   60  14  11   22   0  10    8  13   3    0.000    0.000       0
   1    142 00:01:47.46   0.7550A  -2.3837  -1.2456   1.4341  0.068  0.62  -0.937E+00     48.  0.133E+01  0.611E-01  0.195E-02  0.165E-03   60  14  11   22   0   9    8  13   3    0.000    0.000       0
-  1    143 00:01:48.21   0.7550A  -2.3838  -1.2475   1.4321  0.068  0.62  -0.927E+00     48.  0.133E+01  0.608E-01  0.194E-02  0.166E-03   60  13   9   22   0   9    8  13   3    0.000    0.000       0
+  1    143 00:01:48.21   0.7550A  -2.3838  -1.2475   1.4321  0.068  0.62  -0.927E+00     48.  0.133E+01  0.608E-01  0.194E-02  0.166E-03   60  14  10   22   0   9    8  13   3    0.000    0.000       0
   1    144 00:01:48.97   0.7550A  -2.3839  -1.2648   1.4275  0.067  0.62  -0.916E+00     48.  0.133E+01  0.604E-01  0.194E-02  0.166E-03   60  13   9   22  19   9    8  13   3    0.000    0.000       0
   1    145 00:01:49.72   0.7550A  -2.3839  -1.2658   1.4337  0.067  0.63  -0.911E+00     48.  0.133E+01  0.601E-01  0.194E-02  0.166E-03   60  13   8   22  19   9    9  13   3    0.000    0.000       0
@@ -73,8 +73,8 @@
   1    157 00:01:58.78   0.7550A  -2.3848  -1.2302   1.4154  0.066  0.66  -0.878E+00     50.  0.132E+01  0.557E-01  0.189E-02  0.160E-03   60  10  19   23  16   5   20  14  16    0.000    0.000       0
   1    158 00:01:59.54   0.7550A  -2.3849  -1.2246   1.4282  0.066  0.66  -0.876E+00     50.  0.132E+01  0.553E-01  0.189E-02  0.159E-03   60   9  17   22  17   6   20  14  16    0.000    0.000       0
-  1    159 00:02:00.29   0.7550A  -2.3849  -1.2143   1.4402  0.066  0.67  -0.879E+00     50.  0.132E+01  0.549E-01  0.189E-02  0.158E-03   60   9  16   21  17   7   20  14  16    0.000    0.000       0
+  1    159 00:02:00.29   0.7550A  -2.3850  -1.2143   1.4402  0.066  0.67  -0.879E+00     50.  0.132E+01  0.549E-01  0.189E-02  0.158E-03   60   9  16   21  17   7   20  14  16    0.000    0.000       0
   1    160 00:02:01.05   0.7550A  -2.3850  -1.2267   1.4485  0.066  0.67  -0.876E+00     50.  0.132E+01  0.545E-01  0.188E-02  0.156E-03   60   9  16   21  17   7   20  14  16    0.000    0.000       0
-  1    161 00:02:01.80   0.7550A  -2.3851  -1.2264   1.4512  0.066  0.68  -0.871E+00     52.  0.131E+01  0.541E-01  0.188E-02  0.155E-03   60   9  16   21  17   7   20  14  16    0.000    0.000       0
-  1    162 00:02:02.56   0.7550A  -2.3852  -1.2129   1.4474  0.066  0.68  -0.869E+00     52.  0.131E+01  0.537E-01  0.187E-02  0.153E-03   60   8  14   21  17   7   20  14  16    0.000    0.000       0
+  1    161 00:02:01.80   0.7550A  -2.3851  -1.2264   1.4512  0.066  0.68  -0.871E+00     52.  0.131E+01  0.541E-01  0.188E-02  0.155E-03   60   9  15   21  17   7   20  14  16    0.000    0.000       0
+  1    162 00:02:02.56   0.7550A  -2.3852  -1.2130   1.4474  0.066  0.68  -0.869E+00     52.  0.131E+01  0.537E-01  0.187E-02  0.153E-03   60   8  14   21  17   7   20  14  16    0.000    0.000       0
   1    163 00:02:03.31   0.7550A  -2.3852  -1.1858   1.4383  0.066  0.69  -0.867E+00     52.  0.131E+01  0.533E-01  0.187E-02  0.152E-03   60   8  13   21  17   7   20  14  17    0.000    0.000       0
   1    164 00:02:04.07   0.7550A  -2.3853  -1.1919   1.4420  0.066  0.69  -0.865E+00     52.  0.131E+01  0.530E-01  0.186E-02  0.150E-03   60   8  13   21  16   6   20  14  17    0.000    0.000       0
@@ -82,5 +82,5 @@
   1    166 00:02:05.58   0.7550A  -2.3854  -1.1813   1.4446  0.066  0.70  -0.862E+00     52.  0.131E+01  0.522E-01  0.184E-02  0.146E-03   60   7  10   21  16   6   22  14  16    0.000    0.000       0
   1    167 00:02:06.33   0.7550A  -2.3855  -1.1855   1.4438  0.066  0.70  -0.861E+00     52.  0.131E+01  0.518E-01  0.184E-02  0.145E-03   60   7  10   20  16   7   20  14  17    0.000    0.000       0
-  1    168 00:02:07.09   0.7550A  -2.3856  -1.1984   1.4424  0.065  0.70  -0.860E+00     52.  0.131E+01  0.515E-01  0.183E-02  0.144E-03   60   6   8   20  16   7   20  14  17    0.000    0.000       0
+  1    168 00:02:07.09   0.7550A  -2.3856  -1.1985   1.4424  0.065  0.70  -0.860E+00     52.  0.131E+01  0.515E-01  0.183E-02  0.144E-03   60   6   8   20  16   7   20  14  17    0.000    0.000       0
   1    169 00:02:07.84   0.7550A  -2.3857  -1.1996   1.4399  0.065  0.71  -0.859E+00     52.  0.131E+01  0.511E-01  0.183E-02  0.143E-03   60   6   7   20  16   7   20  14  17    0.000    0.000       0
   1    170 00:02:08.60   0.7540A  -2.3857  -1.1894   1.4363  0.065  0.71  -0.859E+00     52.  0.131E+01  0.508E-01  0.183E-02  0.143E-03   60   6   7   20  16   7   23  14  16    0.000    0.000       0
@@ -90,5 +90,5 @@
   1    174 00:02:11.61   0.7540A  -2.3860  -1.2886   1.3953  0.065  0.76  -0.858E+00     60.  0.131E+01  0.495E-01  0.181E-02  0.142E-03   60  18   2   26  12  16   20  14  17    0.000    0.000       0
   1    175 00:02:12.37   0.7540A  -2.3861  -1.3028   1.3791  0.064  0.76  -0.864E+00     60.  0.130E+01  0.492E-01  0.181E-02  0.143E-03   60   4   1   26  12  16   20  14  17    0.000    0.000       0
-  1    176 00:02:13.12   0.7540A  -2.3862  -1.2817   1.3611  0.064  0.77  -0.877E+00     60.  0.130E+01  0.489E-01  0.181E-02  0.143E-03   60  17  19   26  12  16   20  14  17    0.000    0.000       0
+  1    176 00:02:13.12   0.7540A  -2.3862  -1.2818   1.3610  0.064  0.77  -0.877E+00     60.  0.130E+01  0.489E-01  0.181E-02  0.143E-03   60  17  19   26  12  16   20  14  17    0.000    0.000       0
   1    177 00:02:13.88   0.7540A  -2.3862  -1.3029   1.3395  0.064  0.77  -0.856E+00     60.  0.130E+01  0.487E-01  0.180E-02  0.143E-03   60   3  18   25  12  16   20  14  17    0.000    0.000       0
   1    178 00:02:14.63   0.7540A  -2.3863  -1.3562   1.3123  0.064  0.77  -0.851E+00     60.  0.130E+01  0.484E-01  0.180E-02  0.143E-03   60   3  18   26  11  15   20  14  17    0.000    0.000       0
@@ -96,7 +96,7 @@
   1    180 00:02:16.14   0.7540A  -2.3865  -1.3720   1.3021  0.063  0.77  -0.848E+00     60.  0.130E+01  0.479E-01  0.178E-02  0.142E-03   60   2  15   26  11  15    8  14   3    0.000    0.000       0
   1    181 00:02:16.89   0.7540A  -2.3865  -1.3415   1.3031  0.063  0.77  -0.847E+00     60.  0.130E+01  0.477E-01  0.178E-02  0.141E-03   60   2  15   26  11  15    8  14   3    0.000    0.000       0
-  1    182 00:02:17.65   0.7540A  -2.3866  -1.3268   1.3036  0.063  0.78  -0.847E+00     60.  0.130E+01  0.475E-01  0.177E-02  0.140E-03   60  15  13   26  10  14    8  14   3    0.000    0.000       0
+  1    182 00:02:17.65   0.7540A  -2.3866  -1.3268   1.3035  0.063  0.78  -0.847E+00     60.  0.130E+01  0.475E-01  0.177E-02  0.140E-03   60  15  13   26  10  14    8  14   3    0.000    0.000       0
   1    183 00:02:18.40   0.7540A  -2.3867  -1.3536   1.3035  0.063  0.78  -0.847E+00     60.  0.130E+01  0.473E-01  0.176E-02  0.138E-03   60   1  12   26  10  14    8  14   3    0.000    0.000       0
   1    184 00:02:19.15   0.7540A  -2.3868  -1.3519   1.3029  0.063  0.78  -0.848E+00     60.  0.130E+01  0.471E-01  0.175E-02  0.136E-03   60   1  12   26  10  14    8  14   3    0.000    0.000       0
   1    185 00:02:19.91   0.7540A  -2.3868  -1.3299   1.3016  0.062  0.78  -0.849E+00     60.  0.130E+01  0.470E-01  0.174E-02  0.134E-03   60   1  11   26  10  14    8  14   3    0.000    0.000       0
-  1    186 00:02:20.66   0.7540A  -2.3869  -1.2961   1.2992  0.062  0.78  -0.849E+00     60.  0.130E+01  0.468E-01  0.174E-02  0.132E-03   60   0  10   26  10  14    8  14   3    0.000    0.000       0
+  1    186 00:02:20.66   0.7540A  -2.3869  -1.2962   1.2992  0.062  0.78  -0.849E+00     60.  0.130E+01  0.468E-01  0.174E-02  0.132E-03   60   0  10   26  10  14    8  14   3    0.000    0.000       0