Index: palm/trunk/UTIL/inifor/src/inifor_defs.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 4713)
+++ palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 4714)
@@ -214,5 +214,5 @@
     ACHAR( 10 ) // ' Copyright 2017-2020 Deutscher Wetterdienst Offenbach' !< Copyright notice
  CHARACTER(LEN=*), PARAMETER ::  LOG_FILE_NAME = 'inifor.log' !< Name of INIFOR's log file
- CHARACTER(LEN=*), PARAMETER ::  VERSION = '2.1.0'            !< INIFOR version number
+ CHARACTER(LEN=*), PARAMETER ::  VERSION = '2.1.1'            !< INIFOR version number
  
  END MODULE inifor_defs
Index: palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 4713)
+++ palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 4714)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Minor logging corrections
+!
+!
+! 4675 2020-09-11 10:00:26Z eckhard
 ! Support for profile initialization of soil and for homogeneous (profile)
 !    boundary conditions, including respective command-line options
@@ -516,21 +520,20 @@
     CALL validate_config( cfg ) 
 
-    CALL report('setup_parameters', "atmosphere initialization mode: " // TRIM(cfg%ic_mode))
-    CALL report('setup_parameters', "      soil initialization mode: " // TRIM(cfg%isc_mode))
-    CALL report('setup_parameters', "                  forcing mode: " // TRIM(cfg%bc_mode))
-    CALL report('setup_parameters', "                averaging mode: " // TRIM(cfg%averaging_mode))
-    CALL report('setup_parameters', "               averaging angle: " // real_to_str(cfg%averaging_angle))
-    CALL report('setup_parameters', "               averaging angle: " // real_to_str(cfg%averaging_angle))
-    CALL report('setup_parameters', "                     data path: " // TRIM(cfg%input_path))
-    CALL report('setup_parameters', "                      hhl file: " // TRIM(cfg%hhl_file))
-    CALL report('setup_parameters', "                  soiltyp file: " // TRIM(cfg%soiltyp_file))
-    CALL report('setup_parameters', "                 namelist file: " // TRIM(cfg%namelist_file))
-    CALL report('setup_parameters', "              output data file: " // TRIM(output_file%name))
+    CALL report('setup_parameters', "atmosphere initialization mode: " // TRIM( cfg%ic_mode ) )
+    CALL report('setup_parameters', "      soil initialization mode: " // TRIM( cfg%isc_mode ) )
+    CALL report('setup_parameters', "                  forcing mode: " // TRIM( cfg%bc_mode ) )
+    CALL report('setup_parameters', "                averaging mode: " // TRIM( cfg%averaging_mode ) )
+    CALL report('setup_parameters', "               averaging angle: " // TRIM( real_to_str( cfg%averaging_angle ) )// " deg" )
+    CALL report('setup_parameters', "                     data path: " // TRIM( cfg%input_path ) )
+    CALL report('setup_parameters', "                      hhl file: " // TRIM( cfg%hhl_file ) )
+    CALL report('setup_parameters', "                  soiltyp file: " // TRIM( cfg%soiltyp_file ) )
+    CALL report('setup_parameters', "                 namelist file: " // TRIM( cfg%namelist_file ) )
+    CALL report('setup_parameters', "              output data file: " // TRIM( output_file%name ) )
     IF (cfg%process_precipitation )  THEN
-        CALL report('setup_parameters', "      precipitation: enabled")
+        CALL report('setup_parameters', "                 precipitation: enabled" )
     ELSE
-        CALL report('setup_parameters', "      precipitation: disabled")
+        CALL report('setup_parameters', "                 precipitation: disabled" )
     ENDIF
-    IF (cfg%debug )  CALL report('setup_parameters', "     debugging mode: enabled")
+    IF (cfg%debug )  CALL report('setup_parameters', "     debugging mode: enabled" )
 
     CALL log_runtime('time', 'init')
@@ -1664,5 +1667,5 @@
           message = "Averaging grid kind '" // TRIM(avg_grid%kind) // &
                     "' is not supported. Use 'scalar', 'u', or 'v'."
-          CALL inifor_abort('get_latlon_averaging_region', message)
+          CALL inifor_abort('init_averaging_grid', message)
 
     END SELECT
Index: palm/trunk/UTIL/inifor/src/inifor_transform.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 4713)
+++ palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 4714)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Fixed off-by-one indexing error for profile quantities
+!
+!
+! 4675 2020-09-11 10:00:26Z eckhard
 ! Improved code formatting
 ! 
@@ -378,5 +382,5 @@
  SUBROUTINE interp_average_profile(source_array, profile_array, avg_grid)
     TYPE(grid_definition), INTENT(IN)          ::  avg_grid
-    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array
+    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array(0:,0:,:)
     REAL(wp), DIMENSION(:), INTENT(OUT)        ::  profile_array
 
@@ -435,5 +439,5 @@
 
     TYPE(grid_definition), INTENT(IN)          ::  avg_grid
-    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array
+    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array(0:,0:,:)
     REAL(wp), DIMENSION(:), INTENT(OUT)        ::  profile_array
 
@@ -481,5 +485,5 @@
 
     TYPE(grid_definition), INTENT(IN)          ::  cosmo_grid, avg_grid
-    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  cosmo_pressure
+    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  cosmo_pressure(0:,0:,:)
     REAL(wp), DIMENSION(:), INTENT(OUT)        ::  profile_array
 